function [matData_miss_d, mat_past] = season_comp(MS, vseason)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Input:
% MS                = column vector with missing data
% vseason           = seasonality parameters (used only if flag_season~=0)
%Output:
% matData_miss_d    = column vector with missing data
% mat_past          = past data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mat_past    = zeros(size(MS,1),size(MS,2)*length(vseason));

for ns=1:length(vseason)
    [MS, mat_past(:,(ns-1)*size(MS,2)+1:ns*size(MS,2))] = s_comp(MS, vseason(ns));
end

matData_miss_d  = MS;

end %function

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [matData_miss_d, mat_past] = s_comp(MS, period)
 
    ff                  = (MS~=0);
    LL                  = length(MS);
    ll                  = floor(LL/period)*period;
    past_long           = [zeros(LL-ll+period,1); MS(1:ll-period); MS(ll-period+1:ll); MS(1:LL-period)];
    past                = [MS(ll-period+1:ll); MS(1:LL-period)]; 
    ffz                 = find(past==0);
    
    for i=1:length(ffz)
        pos = ffz(i);
        
            for ind=0:(period-1)
          % for ind=0:4
                if pos<=period
                    temp = past_long(LL+pos-ind:-period:LL-ll+2*period+1); %!!!!!!!
                else
                    temp = past_long(LL+pos-ind:-period:LL+1);
                end
                
                fft = find(temp~=0,1);
                
                if numel(fft)>0
                    past(pos) = temp(fft);
                    break;
                end %if
            end %ind
        
    end %i
       
    difft               = MS - past;  
    matData_miss_d      = difft.*ff;
    mat_past            = past;
   
    
end %function
