function [ytrue, y, yres, ymask, pos] = restore_data(matData, place, Ytrue, Y, D, X, signal_shift, posc)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Input:
% matData
% place
% Ytrue         = original data (no missing data)
% Y             = Y used in training 
% D             = dictionary
% X             = representation
% posc           
% signal_shift 
%Output:
% ytrue = Ytrue written as a column vector
% y     = Y written as a column vector
% yres  = approx. signal (column vector)
% ymask = has zeros in the positions corresponding to the missing data
% pos   = beginning of each time series
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[m,N] = size(Y); % size training data

Yres = D*X; % restored Y

L = N*signal_shift + (m-signal_shift);      % should be equal to length_data * no. of time series (not always)
y = zeros(L,1);                             % the signal (including missing data)
yres = zeros(L,1);                          % the restored signal
ytrue = zeros(L,1);                         % original data
nav = zeros(L,1);                           % number of signals to average at restoration

j = 1;
k = 1;
pos = zeros(1,length(place));
for i = 1 : signal_shift : L-m+1    % slow version now...
  if j==posc(k)
      pos(k) = i;
      if k<length(place)
         k = k+1;
       end
  end

      
  y(i:i+m-1) = Y(:,j);
  ytrue(i:i+m-1) = Ytrue(:,j);
%   if Ytrue(1,j)==matData(1,place(k))
%       pos(k) = i;
%       if k<length(place)
%         k = k+1;
%       end
%   end
  yres(i:i+m-1) = yres(i:i+m-1) + Yres(:,j);
  nav(i:i+m-1) = nav(i:i+m-1) + ones(m,1);
  j = j+1;
end
yres = yres ./ nav;

ymask = (y ~= 0);

end %function

