function [matData_miss_d, mat_past] = season_comp(matData_miss, vseason)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Input:
% matData_miss      = matrix with missing data
% vseason           = seasonality parameters (used only if flag_season~=0)
%Output:
% matData_miss_d    = matrix with missing data
% mat_past          = past data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

MS          = matData_miss;
mat_past    = zeros(size(MS,1),size(MS,2)*length(vseason));

for ns=1:length(vseason)
    [MS, mat_past(:,(ns-1)*size(MS,2)+1:ns*size(MS,2))] = s_comp(MS, vseason(ns));
end

matData_miss_d  = MS;

end %function

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [matData_miss_d, mat_past] = s_comp(matData_miss, period)

mat_past = zeros(size(matData_miss));

for k=1:size(matData_miss,2)
    
    ff                  = (matData_miss(:,k)~=0);
    LL                  = length(matData_miss(:,k));
    ll                  = floor(LL/period)*period;
    past_long           = [zeros(LL-ll+period,1); matData_miss(1:ll-period,k); matData_miss(ll-period+1:ll,k); matData_miss(1:LL-period,k)];
    past                = [matData_miss(ll-period+1:ll,k); matData_miss(1:LL-period,k)]; 
    ffz                 = find(past==0);
    
    for i=1:length(ffz)
        pos = ffz(i);
        
            for ind=0:(period-1)
          % for ind=0:4
                if pos<=period
                    temp = past_long(LL+pos-ind:-period:LL-ll+2*period+1); %!!!!!!!
                else
                    temp = past_long(LL+pos-ind:-period:LL+1);
                end
                
                fft = find(temp~=0,1);
                
                if numel(fft)>0
                    past(pos) = temp(fft);
                    break;
                end %if
            end %ind
        
    end %i
       
    difft               = matData_miss(:,k) - past;  
    matData_miss_d(:,k) = difft.*ff;
    mat_past(:,k)       = past;
   
% if k==1 
%     figure(5)
%      plot(1:period,matData_miss(1:period,k),'r',1:period,past(1:period),'k');
%      legend('Data','Past');
%     figure(4);
%     subplot(1,2,1);
%     plot(matData_miss(:,k));
%     leg = strcat('k=',num2str(k));
%     legend(leg);
%     subplot(1,2,2);
%     plot(matData_miss_d(:,k));
%     legend('diff');
%     pause
% end

    
end %k
    
end %function
