function [matData,matData_miss] = get_data(fname_c,fname_miss,perc_miss)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Input:
% fname_c           = file name complete dataset
% fname_miss        = file name missing data
% perc_miss         = percentage missing data
% Output:
% matData           = complete dataset
% matData_miss      = missing data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Complete data
if isfile(fname_c)==0
    fprintf('ERROR: the file %s does not exist!\n', fname_c);
    matData = [];
    matData_miss = [];
    return;
else
    load(fname_c,'matData');
end

%Missing data
flag = 0;
if isfile(fname_miss)==0
    flag = 1;
else
    load(fname_miss,'matData_miss','perc');
    if size(matData)~=size(matData_miss)
        flag = 1;
    else
        temp = matData;
        temp(matData_miss==0) = 0;
        if sum(sum(temp-matData_miss)) ~=0 
            flag = 1;
        end
    end
    if perc~=perc_miss
        flag = 1;
    end
end

if flag == 1
    %force missing values
    matData_miss = matData;
    perc = perc_miss;
    for k = 1 : size(matData_miss,2)
        ind = randperm(size(matData_miss,1), round(perc * size(matData_miss,1)));
        matData_miss(ind,k)=0;
    end
    save(fname_miss,'matData_miss','perc');
end


end %function

