% Copyright (c) 2017 Paul Irofti <paul@irofti.net>
% 
% Permission to use, copy, modify, and/or distribute this software for any
% purpose with or without fee is hereby granted, provided that the above
% copyright notice and this permission notice appear in all copies.
% 
% THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
% WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
% MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
% ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
% WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
% ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
% OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

function I = avgcol2im(vals, m, n, p1, p2)
%% Average overlapping pixels resulted from im2col sliding
% INPUTS:
%   vals -- overlapping patches
%   m -- original image rows
%   n -- original image columns
%   p1,p2 -- patch size
% OUTPUTS:
%   I -- image resulted by overlapping pixel value averaging
    if nargin < 5
        p2 = p1;
    end
    inds = reshape(1:m*n,[m n]);
    subs = im2col(inds, [p1 p2], 'sliding');
    I = accumarray(subs(:),vals(:))./accumarray(subs(:),1);
    I = reshape(I,m,n);
end